.model small
.stack 100H
	
.data
 
help    	db 'Programa pakeicia eilutes faile.',13,10,'Parametru ivedimo pav.: tekstas.txt 2 3',13,10,'$'
err_s    	db 'Failo nepavyko atidaryti skaitymui',13,10,'$'
file	   	db 100 dup (0)
handle		dw ?
pirmeil         db 0
antreil         db 0
buffer1  	db 255 dup (?)
buffer2     	db 255 dup (?)
simbolis 	db ?
KlaidaAtd	db 'Klaida atidarant faila!',10,13,'$'
KlaidaUzd	db 'Klaida uzdarant faila!',10,13,'$'		
Neiv		db 'Netinkamai ivesti parametrai!', 10, 13, '$'	
KlaidaSk	db 'Klaida skaitant faila!',10,13,'$'	

.code

START:
	MOV	ax, @data				; perkeliam i ax duomenu segmento pradzios adresa
	MOV	ds, ax					; i ds perkeliam ax turini (duomenu segmento pradzios adresa)
	MOV	bx, 0081h				; programos paleidimo parametrai rasomi segmente es pradedant 129

Ieskok:
	MOV	ax, es:[bx]				; i ax irasom du baitus, i kuriuos rodo registro turinio adresas bx
	CMP	al, 0Dh					; tikrinam, ar tai ne pabaigos simbolis (pabaigos simbolis - '0Dh')
	JE	Nera					; jei taip, vadinasi neradau '/?', persokam i 'nera'
	CMP	ax, 3F2Fh				; o gal nuskaityta '/?' - 3F = '?'; 2F = '/' (paliginam ax su 3F2F)
	JE	Yra             			; radau '/?', vadinasi turiu isvesti pagalbos pranesima, persokam i 'Yra'
	INC	bx					; neradau '/?' siuose baituose, paslenku rodykli 
	JMP	Ieskok					; uzciklinu, pradedem cikla 'Ieskok' is naujo...


;failo vardo ieskojimas ir irasymas

Yra:						; spausdinu pagalba i ekrana
	MOV	ah, 9				; i ah irasom dosinio pertraukimo funkcijos numeri 9
	MOV	dx, offset help			; i dx ikeliam kintamojo 'help' adresa
	INT	21h				; iskvieciu dosini pertraukima - spausdinu pranesima
	JMP	galas				; persoka i kintameji 'Pabaiga'

Nera:
	MOV	si, 0080h
 
SpaceSearch1:					; ieskom komandineje eiluteje simbolio nelygaus tarpui
	INC	si				; padidinam si vienetu
	MOV	al, es:[si]			; i al irasom viena simboli, nuskaityta is komandines eilutes
	CMP	al, ' '				; patikrinam ar nuskaitytas simbolis nera tarpas
	JE	SpaceSearch1			; jei al=' ', tai uzciklinam 'SpaceSearch1'
	MOV	bx, offset file 		; i bx ikeliam 'file' adresa, kur bus saugomas failo vardas
 NameSearch1:
	MOV	al, es:[si]			; i al irasom viena simboli, nuskaityta is komandines eilutes
	INC	si				; padidinam si vienetu, kad imtume kita simboli is komandine eilutes
	CMP	al, 0Dh				; patikrinam ar nuskaitytas simbolis nera Enter
	JNC	IeskokToliau1			; jei neivyksta klaidos, nustatomas carry flag (CF=0) , persokam i 'IeskokToliau1'
	;JMP 	galas
	CALL	Neivesta			; jei ivyksta klaida, nustatomas cary flag (CF=1), persokam i 'Neivesta'
 
IeskokToliau1:
	CMP	al, ' '				; patikrinam ar nuskaitytas simbolis nera tarpu
	JE	SpaceSearch2			; jei tai yra Enter persokam i 'SpaceSearch2'
	MOV	ds:[bx], al			; i pirmojo failo varda irasom simboli is komandines eilutes
	INC	bx				; padidinam bx vienetu
	JMP	NameSearch1			; persokam i 'NameSearch1', pildom iki galo 1 duomenu failo varda 

SpaceSearch2:					; ieskom komandineje eiluteje ne tarpa
	MOV	al, es:[si]			; i al irasom viena simboli, nuskaityta is komandines eilutes
	CMP	al, ' '				; patikrinam ar nuskaitytas simbolis nera tarpu
	JE	SpaceSearch2			; jei al=' ', tai uzciklinam 'SpaceSearch2'
 
NameSearch2:
	MOV	al, es:[si]			; i al irasom viena simboli, nuskaityta is komandines eilutes
	INC	si				; padidinam si vienetu
	CMP	al, 0Dh				; patikrinam ar nuskaitytas simbolis nera Enter
	JNC 	IeskokToliau2				
	;JMP 	galas
	CALL	Neivesta			; jei tai yra Enter persokam i 'Neivesta'
 
IeskokToliau2:
	CMP	al, ' '				; patikrinam ar nuskaitytas simbolis nera tarpas
	JE	SpaceSearch3			; jei tai yra tarpas persokam i 'SpaceSearch3'
	MOV	pirmeil, al			
	INC	bx				; padidinam bx vienetu
	JMP	NameSearch2			; persokam i 'NameSearch2'

SpaceSearch3:					; ieskom komandineje eiluteje ne tarpa
	MOV	al, es:[si]			; i al irasom viena simboli, nuskaityta is komandines eilutes
	INC	si				; padidinam si vienetu
	CMP	al, ' '				; patikrinam ar nuskaitytas simbolis nera tarpu
	JE	SpaceSearch3			; jei al=' ', tai uzciklinam 'SpaceSearch3'
	DEC	si				; sumazinam SOURCE INDEX reiksme vienetu, kad matytumem ta nelygu "SPACE" simboli
	MOV	al, es:[si]			; i al irasom ta simboli nelygu tarpui
	CMP	al, 0Dh				; patikrinam ar irasytas simbolis nera Enter
	JE	Neivesta			; jei tai yra Enter persokam i 'Neivesta'
	JNC 	IeskokToliau3			; jei ieskant rezultato failo varda neivyksta klaidos, nustatomas carry flag (CF=0)

 
IeskokToliau3:
	;MOV	bx, offset antreil		; i bx ikeliam 'rezu' adresa, kur bus saugomas pirma failo vardas
 
NameSearch3:
	MOV	al, es:[si]			; i al irasom viena simboli, nuskaityta is komandines eilutes
	INC	si				; padidinam si vienetu
	CMP	al, 0Dh				; patikrinam ar nuskaitytas simbolis nera Enter
	JE 	Atidarom

 
	CMP	al, ' '				; patikrinam ar nuskaitytas simbolis nera tarpu
	JE	NameSearch3			; jei tai yra tarpas, tai tikrinsiu tolimesni komandines eilutes simboli
	MOV	antreil, al			
	INC	bx				; padidinam bx vienetu
	JMP	NameSearch3			; persokam i 'NameSearch3'

	MOV 	ax, ds				; i ax ikeliam ds
	MOV	es, ax				; i es ikeliam ax (tai reiskia ds), sulyginam ds ir es
Atidarom:
	MOV	ah, 03Dh			; i ah irasom dosinio pertraukimo funkcijos numeri 3Dh	
	MOV	al, 02				; 02 - failas atidaromas skaitymui/rasymui	
	MOV	dx, offset file			; vieta, kur nurodomas failo pavadinimas, pasibaigiantis nuliniu simboliu
	INT	21h				; 21 pertraukimas, failas atidaromas skaitymui
	JNC	Atidaryti			; jei atidarant faila neivyksta klaidos, nustatomas carry flag (CF=0)
	CALL 	KlaidaAtidarant			; jei atidarant faila ivyksta klaida, nustatomas cary flag (CF=1)
 
Atidaryti:
	MOV	[handle], ax			; atmintyje issisaugom failo deskriptoriaus numeri


Vykdom:

Skaityk:
	XOR	ax, ax
	MOV	ah, 03Fh				; i ah irasom dosinio pertraukimo funkcijos numeri 3Fh
	MOV	bx, handle				; i bx irasom 1 duomenu failo desktriptoriaus numeri
	MOV	cl, 255					; cx - kiek baitu reikia nuskaityti is failo
	MOV	ch, 0
	MOV	dx, offset buffer1			; vieta, i kuri irasoma nuskaityta informacija	
	INT	21h					; 21 pertraukimas, duomenu skaitymas
	JNC	Skaityk1				; jei skaitant faila neivyksta klaidos, nustatomas carry flag (CF=0) , persokam i 'Skaityk1'
	CALL	KlaidaSkaitant				; jei skaitant is failo ivyksta klaida, nustatomas carry flag (CF=1)
 
Skaityk1:
	CMP	ax, 0					; priesingu atveju i ax irasoma, kiek baitu buvo nuskaityta
	JE	Uzdaryti	
	MOV	cx, ax					; i cx ikeliam ax, kiek baitu buvo nuskaityta

Atspausdinam:
	MOV	ah, 9				; i ah irasom dosinio pertraukimo funkcijos numeri 9
	MOV	dx, offset buffer1		
	INT 	21h				; 21 petraukimas, pranesimo spausdinimas


Uzdaryti:
	MOV	ah, 03Eh			; i ah irasom dosinio pertraukimo funkcijos numeri 3Eh
	MOV	bx, handle			; i bx irasom failo desktriptoriaus numeri
	INT	21h				; 21 pertraukimas, failo uzdarymas
	JNC	galas				; jei uzdarant faila neivyksta klaidos, nustatomas carry flag (CF=0)
	CALL	KlaidaUzdarant			; jei uzdarant faila ivyksta klaida, nustatomas carry flag (CF=1)

galas: 
   	MOV 	ah, 4ch
   	MOV 	al,00h
   	INT 	21h  

KlaidaAtidarant:				; klaidos pranesimo ivedimo kodas
	MOV	ah, 9				; i ah irasom dosinio pertraukimo funkcijos numeri 9
	MOV	dx, offset KlaidaAtd		; i dx ikeliam kintamojo 'Klaida' adresa 
	INT 	21h				; 21 petraukimas, pranesimo spausdinimas
	JMP	galas

KlaidaUzdarant:				; klaidos pranesimo ivedimo kodas
	MOV	ah, 9				; i ah irasom dosinio pertraukimo funkcijos numeri 9
	MOV	dx, offset KlaidaUzd		; i dx ikeliam kintamojo 'KUR' adresa 
	INT 	21h				; 21 petraukimas, pranesimo spausdinimas
	JMP	galas

Neivesta:					; klaidos pranesimo ivedimo kodas
	MOV	ah, 9				; i ah irasom dosinio pertraukimo funkcijos numeri 9
	MOV	dx, offset Neiv			; i dx ikeliam kintamojo 'Nei' adresa 
	INT 	21h				; 21 petraukimas, pranesimo spausdinimas
	JMP	galas

KlaidaSkaitant:					; klaidos pranesimo ivedimo kodas
	MOV	ah, 9				; i ah irasom dosinio pertraukimo funkcijos numeri 9
	MOV	dx, offset KlaidaSk		; i dx ikeliam kintamojo 'KS' adresa 
	INT 	21h				; 21 petraukimas, pranesimo spausdinimas
	JMP	Uzdaryti

END START